package cn.ibizlab.core.lite.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.lite.domain.DstLookup;
import cn.ibizlab.core.lite.filter.DstLookupSearchContext;
import cn.ibizlab.core.lite.service.IDstLookupService;

import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.helper.DEFieldCacheMap;


/**
 * 实体[lookup] 无存储服务对象接口实现
 */
@Slf4j
@Service
public class DstLookupServiceImpl implements IDstLookupService {


    @Override
    public boolean create(DstLookup et) {
        //代码实现
        return true;
    }

    public void createBatch(List<DstLookup> list){
    }

    @Override
    public boolean update(DstLookup et) {
        //代码实现
        return true;
    }

    public void updateBatch(List<DstLookup> list){
    }

    @Override
    public boolean remove(String key) {
        return true;
    }

    public void removeBatch(Collection<String> idList){
    }

    @Override
    public DstLookup get(String key) {
        DstLookup et = new DstLookup();
        et.setId(key);
        return et;
    }

    @Override
    public DstLookup getDraft(DstLookup et) {
        return et;
    }

    @Override
    public boolean checkKey(DstLookup et) {
        return false;
    }
    @Override
    @Transactional
    public boolean save(DstLookup et) {
        //代码实现
        return true;
    }

    @Override
    public void saveBatch(List<DstLookup> list) {
    }



	@Override
    public List<DstLookup> selectByRelationid(String id) {
        return null;
    }

    @Override
    public void removeByRelationid(String id) {
        Set<String> delIds=new HashSet<String>();
        for(DstLookup before:selectByRelationid(id)){
            delIds.add(before.getId());
        }
        if(delIds.size()>0)
            this.removeBatch(delIds);
    }

    @Autowired
    @Lazy
    IDstLookupService proxyService;
	@Override
    public void saveByRelationid(String id,List<DstLookup> list) {
        if(list==null)
            return;
        Set<String> delIds=new HashSet<String>();
        List<DstLookup> _update=new ArrayList<DstLookup>();
        List<DstLookup> _create=new ArrayList<DstLookup>();
        for(DstLookup before:selectByRelationid(id)){
            delIds.add(before.getId());
        }
        for(DstLookup sub:list) {
            sub.setRelationid(id);
            if(ObjectUtils.isEmpty(sub.getId()))
                sub.setId((String)sub.getDefaultKey(true));
            if(delIds.contains(sub.getId())) {
                delIds.remove(sub.getId());
                _update.add(sub);
            }
            else
                _create.add(sub);
        }
        if(_update.size()>0)
            proxyService.updateBatch(_update);
        if(_create.size()>0)
            proxyService.createBatch(_create);
        if(delIds.size()>0)
            proxyService.removeBatch(delIds);
	}



    /**
     * 查询集合 数据集
     */
    @Override
    public Page<DstLookup> searchDefault(DstLookupSearchContext context) {
        return new PageImpl<DstLookup>(new ArrayList(),context.getPageable(),0);
    }


}


